﻿// Copyright (c) Strange Loop Games. All rights reserved.
// See LICENSE file in the project root for full license information.
// <auto-generated from WorldObjectTemplate.tt />

namespace Eco.Mods.TechTree
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using Eco.Core.Items;
    using Eco.Gameplay.Blocks;
    using Eco.Gameplay.Components;
    using Eco.Gameplay.Components.Auth;
    using Eco.Gameplay.DynamicValues;
    using Eco.Gameplay.Economy;
    using Eco.Gameplay.Housing;
    using Eco.Gameplay.Interactions;
    using Eco.Gameplay.Items;
    using Eco.Gameplay.Modules;
    using Eco.Gameplay.Minimap;
    using Eco.Gameplay.Objects;
    using Eco.Gameplay.Players;
    using Eco.Gameplay.Property;
    using Eco.Gameplay.Skills;
    using Eco.Gameplay.Systems.TextLinks;
    using Eco.Gameplay.Pipes.LiquidComponents;
    using Eco.Gameplay.Pipes.Gases;
    using Eco.Gameplay.Systems.Tooltip;
    using Eco.Shared;
    using Eco.Shared.Math;
    using Eco.Shared.Localization;
    using Eco.Shared.Serialization;
    using Eco.Shared.Utils;
    using Eco.Shared.View;
    using Eco.Shared.Items;
    using Eco.Gameplay.Pipes;
    using Eco.World.Blocks;
    using Eco.Gameplay.Housing.PropertyValues;
    using Eco.Gameplay.Civics.Objects;
    using Eco.Gameplay.Settlements;
    using Eco.Gameplay.Systems.NewTooltip;
    using Eco.Core.Controller;
    using static Eco.Gameplay.Housing.PropertyValues.HomeFurnishingValue;

    [Serialized]
    [RequireComponent(typeof(PropertyAuthComponent))]
    [RequireComponent(typeof(HousingComponent))]
    [RequireComponent(typeof(SolidAttachedSurfaceRequirementComponent))]
    //[Ecopedia("Housing Objects", "Seating", subPageName: "HewnTable Item")]
    public partial class PaperScreenObject : WorldObject, IRepresentsItem
    {
        public virtual Type RepresentedItemType => typeof(PaperScreenItem);
        public override LocString DisplayName => Localizer.DoStr("Paper screen");
        public override TableTextureMode TableTexture => TableTextureMode.Wood;

        protected override void Initialize()
        {
            this.ModsPreInitialize();
            this.GetComponent<HousingComponent>().HomeValue = PaperScreenItem.homeValue;
            this.ModsPostInitialize();
        }
		static PaperScreenObject()
        {
            AddOccupancy<PaperScreenObject>(new List<BlockOccupancy>()
            {
            new BlockOccupancy(new Vector3i(0, 0, 0)),   
            new BlockOccupancy(new Vector3i(-1, 0, 0)),
			new BlockOccupancy(new Vector3i(0, 1, 0)),   
            new BlockOccupancy(new Vector3i(-1, 1, 0)),
            
            });
        }
        /// <summary>Hook for mods to customize WorldObject before initialization. You can change housing values here.</summary> PaperScreenItem
        partial void ModsPreInitialize();
        /// <summary>Hook for mods to customize WorldObject after initialization.</summary>
        partial void ModsPostInitialize();
    }
	//---------------------------------------------
    [Serialized]
    [LocDisplayName("Paper screen")]
    //[Ecopedia("Housing Objects", "Seating", createAsSubPage: true)]
    [Tag("Housing", 1)]
    public partial class PaperScreenItem : WorldObjectItem<PaperScreenObject>
    {
        public override LocString DisplayDescription => Localizer.DoStr("Jack of all trades, do paper crafts");


        public override DirectionAxisFlags RequiresSurfaceOnSides { get;} = 0
                    | DirectionAxisFlags.Down
                ;
        public override HomeFurnishingValue HomeValue => homeValue;
        public static readonly HomeFurnishingValue homeValue = new HomeFurnishingValue()
        {
            Category                 = HousingConfig.GetRoomCategory("Decoration"),
            HouseValue               = 3f,
            TypeForRoomLimit         = Localizer.DoStr("Decoration"),
            DiminishingReturnPercent = 0.1f
        };

    }

    //---------------------------------------------
    [RequiresSkill(typeof(PaperMillingSkill), 2)]
    //[Ecopedia("Housing Objects", "Seating", subPageName: "HewnTable Item")]
    public partial class PaperScreenRecipe : RecipeFamily
    {
        public PaperScreenRecipe()
        {
            var recipe = new Recipe();
            recipe.Init(
                name: "Paper screen",  //noloc
                displayName: Localizer.DoStr("Paper screen"),

                // Defines the ingredients needed to craft this recipe. An ingredient items takes the following inputs
                // type of the item, the amount of the item, the skill required, and the talent used.
                ingredients: new List<IngredientElement>
                {
                    new IngredientElement(typeof(PaperItem), 20, typeof(PaperMillingSkill), typeof(PaperMillingLavishResourcesTalent)),
					new IngredientElement("WoodBoard", 2, typeof(PaperMillingSkill), typeof(PaperMillingLavishResourcesTalent))	
                },

                // Define our recipe output items.
                // For every output item there needs to be one CraftingElement entry with the type of the final item and the amount
                // to create.
                items: new List<CraftingElement>
                {
                    new CraftingElement<PaperScreenItem>()
                });
            this.Recipes = new List<Recipe> { recipe };
            this.ExperienceOnCraft = 2; // Defines how much experience is gained when crafted.
            
            // Defines the amount of labor required and the required skill to add labor
            this.LaborInCalories = CreateLaborInCaloriesValue(60, typeof(PaperMillingSkill));

            // Defines our crafting time for the recipe
            this.CraftMinutes = CreateCraftTimeValue(beneficiary: typeof(PaperScreenRecipe), start: 4, skillType: typeof(PaperMillingSkill), typeof(CarpentryFocusedSpeedTalent), typeof(CarpentryParallelSpeedTalent));

            // Perform pre/post initialization for user mods and initialize our recipe instance with the display name "Hewn Table"
            this.ModsPreInitialize();
            this.Initialize(displayText: Localizer.DoStr("Paper screen"), recipeType: typeof(PaperScreenRecipe));
            this.ModsPostInitialize();

            // Register our RecipeFamily instance with the crafting system so it can be crafted.
            CraftingComponent.AddRecipe(tableType: typeof(PaperTableObject), recipe: this);
        }

        /// <summary>Hook for mods to customize RecipeFamily before initialization. You can change recipes, xp, labor, time here.</summary>
        partial void ModsPreInitialize();

        /// <summary>Hook for mods to customize RecipeFamily after initialization, but before registration. You can change skill requirements here.</summary>
        partial void ModsPostInitialize();
    }
}
